<?php

# moissonneur.php
# Auteur : Emmanuel Pierrez



# Date de creation : 11 avril 2008, derniere MAJ : 1er janvier 2009

# Objectif du script : creer galerie.xml, index.xml  et motclef.html avec les infos IPTC et EXIF d'une image


// session_start();


// Fonction utile pour vérifier si le fichier est une image

function isImg($file){



  $file = explode(".",$file);

  if($file[1] == "jpg" || $file[1] == "JPG"){

    return true;

  }else{

    return false;

  }



}

// fonction pour retourner les données IPTC de l'image

function strip_IPTC($data) {

    if (is_array($data)) {

        foreach ($data as $key=>$item) {

             $data[$key]=strip_IPTC($item);

        }

    } else {

         $data=htmlentities(strip_tags(trim($data,"\x7f..\xff\x0..\x1f")),ENT_QUOTES); //sanitize data against sql/html injection; trim any nongraphical non-ASCII character:

    }

    return $data;

}



function get_IPTC($filename) {

        $IPTC_data=array();

        $size = GetImageSize ($filename, $info);

        if (isset($info["APP13"])) {

            $iptc = iptcparse($info["APP13"]);

            if (is_array($iptc)) {

                $IPTC_data=array(       "Titre"                    =>       $iptc["2#105"][0],

                                        "Priorité"                 =>       $iptc["2#007"][0],

                                        "Statut éditorial"         =>       $iptc["2#010"][0],

                                        "Catégorie"                =>       $iptc["2#015"][0],

                                        "Catégorie supplémentaire" =>       $iptc["2#020"],

                                        "Mots-clés"                =>       $iptc["2#025"],

                                        "Instructions"             =>       $iptc["2#040"][0],

                                        "Date de création"         =>       $iptc["2#055"][0],

                                        "Heure de création"        =>       $iptc["2#060"][0],

                                        "Programme utilisé"        =>       $iptc["2#065"][0],

                                        "Auteur"                   =>       $iptc["2#080"][0],

                                        "Position"                 =>       $iptc["2#085"][0],

                                        "Ville"                    =>       $iptc["2#090"][0],

                                        "Région"                   =>       $iptc["2#092"][0],

                                        "Pays"                     =>       $iptc["2#101"][0],

                                        "Référence de transmission"=>       $iptc["2#103"][0],

                                        "NomObjet"                 =>       $iptc["2#005"][0],

                                        "Crédit"                   =>       $iptc["2#110"][0],

                                        "Source"                   =>       $iptc["2#115"][0],

                                        "Copyright"                =>       $iptc["2#116"][0],

                                        "Légende"                  =>       $iptc["2#120"][0],

                                        "RedacteurLégende"         =>       $iptc["2#122"][0],

                );

                $IPTC_data=strip_IPTC($IPTC_data);

		//sanitize data against sql/html injection; trim any nongraphical non-ASCII character:

                //$IPTC_data=filter_content($IPTC_data);

		//run the data against the bad word list

            }

	    return $IPTC_data;

        }

}



// A faire : sous répertoire $dir

$handle = @opendir("./galerie/") or die("|galerie|$dir| Erreur d'ouverture du répertoire !") ;

$imgList = array();

$iptc    = array();

$exif    = array();



while (false !== ($file = readdir($handle))) {



 if ($file != "." && $file != ".." && $file != "user" && $file != "thumbnail" && isImg($file)) {

	 $imgList[] = $file;

	 $iptc[] = get_IPTC("./galerie/".$file);

	 $exif[] = exif_read_data("./galerie/".$file, 'IFD0');

 }

}



closedir($handle);



// SET

$illustration = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE set [
	<!ENTITY Agrave "&#192;">
	<!ENTITY Aacute "&#193;">
	<!ENTITY Acirc "&#194;">
	<!ENTITY AElig "&#198;">
	<!ENTITY Ccedil "&#199;">
	<!ENTITY Egrave "&#200;">
	<!ENTITY Eacute "&#201;">
	<!ENTITY Ecirc "&#202;">
	<!ENTITY Igrave "&#204;">
	<!ENTITY Iacute "&#205;">
	<!ENTITY Icirc "&#206;">
	<!ENTITY Ograve "&#210;">
	<!ENTITY Oacute "&#211;">
	<!ENTITY Ocirc "&#212;">
	<!ENTITY Ugrave "&#217;">
	<!ENTITY Uacute "&#218;">
	<!ENTITY Ucirc "&#219;">
	<!ENTITY agrave "&#224;">
	<!ENTITY aacute "&#225;">
	<!ENTITY acirc "&#226;">
	<!ENTITY aelig "&#230;">
	<!ENTITY ccedil "&#231;">
	<!ENTITY egrave "&#232;">
	<!ENTITY eacute "&#233;">
	<!ENTITY ecirc "&#234;">
	<!ENTITY igrave "&#236;">
	<!ENTITY iacute "&#237;">
	<!ENTITY icirc "&#238;">
	<!ENTITY ograve "&#242;">
	<!ENTITY oacute "&#243;">
	<!ENTITY ocirc "&#244;">
	<!ENTITY ugrave "&#249;">
	<!ENTITY uacute "&#250;">
	<!ENTITY ucirc "&#251;">]>

<set>

</set>';

$dates = array();

$xml = simplexml_load_string($illustration);



// info

$info = $xml->addChild('info');

$info->addChild('identifier','galerie');



$creator  = $info->addChild('creator');

$creator->addChild('unqualified','Emmanuel Pierrez');



$date  = $info->addChild('date');

$date->addChild('unqualified','02/05/2008');

$date->addAttribute('role','created');

$date  = $info->addChild('date');



$date->addChild('unqualified',date('d/m/Y'));

$date->addAttribute('role','modified');



$info->addChild('description','un résumé');



$rights  = $info->addChild('rights');

$rights->addChild('unqualified','Reproduction soumise à autorisation');



// boucle sur les record

$i=0;

while($i < count($imgList)) {

// RECORD

$record = $xml->addChild('record');

// info

$infoRec = $record->addChild('info');

$infoRec->addChild('identifier',$exif[$i]['FileName']);



$publisher = $infoRec->addChild('publisher');

$publisher->addChild('unqualified',$iptc[$i]['RedacteurLégende']);



$date = $infoRec->addChild('date');

$date->addAttribute('role','created');

$date->addChild('unqualified',date('Ymd',$exif[$i]['FileDateTime']));

//

$dates[]  = array(date('Ymd',$exif[$i]['FileDateTime']),$exif[$i]['FileName']);

// title

$title = $record->addChild('title');

$title->addChild('proper',$iptc[$i]['Titre']);



// description

$description = $record->addChild('description',$iptc[$i]['Légende']);

$description->addAttribute('scheme', 'abstract');



// source

$source   = $record->addChild('source');

$resource = $source->addChild('resource');

$creator  = $resource->addChild('creator');

$creator->addChild('unqualified',$iptc[$i]['Auteur']);



// type

$record->addChild('type',$exif[$i]['ImageType']);



// coverage

$coverage = $record->addChild('coverage');

$place    = $coverage->addChild('place');

$geoname  = $place->addChild('geoname');

$location = $geoname->addChild('location');

$location->addChild('country',$iptc[$i]['Pays']);

$location->addChild('region',$iptc[$i]['Région']);

$locality = $location->addChild('locality',$iptc[$i]['Ville']);

$locality->addAttribute('role', 'commune');



// subject boucle sur les subjects

$j=0;

while($j < count($iptc[$i]["Mots-clés"])) {

	$subject = $record->addChild('subject');

	$subject->addChild('topicname',$iptc[$i]["Mots-clés"][$j]);

   $j++;

}



// droits sur l'image



// fin record

   $i++;

}


// les 30 dernières images
asort($dates); // tri selon indice
$nbredates = (count($dates) < 30) ? count($dates) : 30 ;
//echo $nbredates;
for ($j=0;$j<$nbredates;$j++) {

	$source = $info->addChild('source',$dates[$j][0]);
	$source->addAttribute('uri',$dates[$j][1]);

}


$xml->asXML('galerie.xml');


// Créer index.xml a partir du fichier galerie.xml

// Ouvrir galerie.xml qui contient les mots clés
if (file_exists('galerie.xml')) {
    $xml = simplexml_load_file('galerie.xml');
    //var_dump($xml);
} else {
    exit('Echec lors de l\'ouverture du fichier galerie.xml.');
}

// Boucler sur les record et créer une paire mot-clé nomimage $paire1={"Auvergne","img_1234.jpg"}
$result = $xml->xpath('/set/record');

while(list( , $node) = each($result)) {

	$record   = $node->info->identifier ;
	$country  = $node->coverage->place->geoname->location->country ;
	$region   = $node->coverage->place->geoname->location->region ;
	$locality = $node->coverage->place->geoname->location->locality ;
	//$dates[]  = array($node->info->date->unqualified,$node->info->identifier);
	//$annee    = substr($node->info->date->unqualified,-4);

	if ($country != "") {
	$paire[] = array($record,$country);
	}
	if ($region != "") {
	$paire[] = array($record,$region);
	}
	if ($locality != "") {
	$paire[] = array($record,$locality);
	}
	/*if ($annee != "") {
	$paire[] = array($record,$annee);
	}*/
	
	//echo $record," : ",$locality,"<br />";
	
	foreach ($node->subject as $subject) {

		$paire[] = array($record,$subject->topicname);
		//echo $subject->topicname, ' / ';

	}
	
	//echo "<br />";
	
}

while (list($indice,$mot)=each($paire)) {
	//echo  "<b>" . $indice . " ";
	//echo          $mot[0]. " / " . $mot[1]      . "</b><br />";
	
 	if (isset(${$mot[1]})) {
		${$mot[1]}[]=$mot[0];
		//echo $mot[0];
	} else {
		${$mot[1]}[]=$mot[0];
	}
	
	$input[] = $mot[1] ;

}

// index.xml

$xmlcible = '<?xml version="1.0" encoding="UTF-8"?>
	<!DOCTYPE set [
	<!ENTITY Agrave "&#192;">
	<!ENTITY Aacute "&#193;">
	<!ENTITY Acirc "&#194;">
	<!ENTITY AElig "&#198;">
	<!ENTITY Ccedil "&#199;">
	<!ENTITY Egrave "&#200;">
	<!ENTITY Eacute "&#201;">
	<!ENTITY Ecirc "&#202;">
	<!ENTITY Igrave "&#204;">
	<!ENTITY Iacute "&#205;">
	<!ENTITY Icirc "&#206;">
	<!ENTITY Ograve "&#210;">
	<!ENTITY Oacute "&#211;">
	<!ENTITY Ocirc "&#212;">
	<!ENTITY Ugrave "&#217;">
	<!ENTITY Uacute "&#218;">
	<!ENTITY Ucirc "&#219;">
	<!ENTITY agrave "&#224;">
	<!ENTITY aacute "&#225;">
	<!ENTITY acirc "&#226;">
	<!ENTITY aelig "&#230;">
	<!ENTITY ccedil "&#231;">
	<!ENTITY egrave "&#232;">
	<!ENTITY eacute "&#233;">
	<!ENTITY ecirc "&#234;">
	<!ENTITY igrave "&#236;">
	<!ENTITY iacute "&#237;">
	<!ENTITY icirc "&#238;">
	<!ENTITY ograve "&#242;">
	<!ENTITY oacute "&#243;">
	<!ENTITY ocirc "&#244;">
	<!ENTITY ugrave "&#249;">
	<!ENTITY uacute "&#250;">
	<!ENTITY ucirc "&#251;">]>


<index>

</index>';



$index = simplexml_load_string($xmlcible);

// info

$info = $index->addChild('info');

$info->addChild('identifier','index de la galerie');



$creator  = $info->addChild('creator');

$creator->addChild('unqualified','Emmanuel Pierrez');



$date  = $info->addChild('date');

$date->addChild('unqualified','03/01/09');

$date->addAttribute('role','created');

$date  = $info->addChild('date');



$date->addChild('unqualified',date('d/m/Y'));

$date->addAttribute('role','modified');



$info->addChild('description',"Index permettant d'afficher les photos par mot clé.");



$rights  = $info->addChild('rights');

$rights->addChild('unqualified','Reproduction soumise à autorisation');


// supprimer les doublons des mots clés
$motcle = array_unique($input);

$occurence = array();

while (list(,$nom1)=each($motcle)) {
	echo "<strong>" . $nom1 . " " . count($$nom1) . "</strong> - ";
	$occurence[] = count($$nom1);
	// term
	$term = $index->addChild('term');
	$term->addAttribute('class',count($$nom1));
	$term->addChild('primary',$nom1);
	
	while (list(,$nom2)=each($$nom1)) {
	  echo $nom2 . " / ";
	  // see
	  $see = $term->addChild('see');
	  $see->addAttribute('uri',$nom2);
	}
	echo"<br/>";
}

$index->asxml('index.xml');

// motclef.html

// calcul du quartile

sort($occurence, SORT_NUMERIC);
//var_dump($occurence);
$nbreval = count($occurence);
$posmediane  = ($nbreval+1)/2;
$etendue     =  $occurence[$nbreval-1] - $occurence[0] ;
$mediane  = $posmediane + ceil($occurence[$posmediane]-1) - floor($occurence[$posmediane]-1);
echo "Etendue : " . $etendue ." Mediane : " . $mediane . " calculee a partir de " . $nbreval . " valeurs<br/>";
$qartile1 = $occurence[floor($posmediane/2)-1];
$qartile3 = $occurence[floor($posmediane/2+$posmediane)-1];
echo $qartile1 ." / " . $qartile3 . "<br/>";

$content = '<div id="motclef"><h3>Tous les mots clefs</h3><p>';

$motcle = array_unique($input);

while (list(,$nom)=each($motcle)) {
	$taille = (count($$nom) > $qartile1) ? "1.3em" : "1em";
	$taille = (count($$nom) > $mediane)  ? "1.6em" : $taille;
	$taille = (count($$nom) > $qartile3) ? "2em"   : $taille;
	$content .="<span style='font-size:" . $taille .  "'><a href='?motclef=" . $nom . "'>" . $nom . "</a></span> ";
}

$content .= '</p></div>';

$ouvre=fopen("motclef.html","w+");
fwrite($ouvre,$content);
fclose($ouvre);


//echo $content;

echo"Le travail est fini !";

?>

